diff --git a/src/backend/optimizer/util/inherit.c b/src/backend/optimizer/util/inherit.c
index f51ce45cd3..2df548bce5 100644
--- a/src/backend/optimizer/util/inherit.c
+++ b/src/backend/optimizer/util/inherit.c
@@ -942,9 +942,13 @@ translate_col_privs_multilevel(PlannerInfo *root, RelOptInfo *rel,
 	if (rel->parent != top_parent_rel)
 	{
 		if (rel->parent)
+		{
 			result = translate_col_privs_multilevel(root, rel->parent,
 													top_parent_rel,
 													top_parent_cols);
+
+			return result;
+		}
 		else
 			elog(ERROR, "rel with relid %u is not a child rel", rel->relid);
 	}